VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "IO-Warrior Grossuhr von  Andreas Khler"
   ClientHeight    =   1980
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5115
   LinkTopic       =   "Form1"
   MousePointer    =   3  'I-Cursor
   OLEDropMode     =   1  'Manuell
   ScaleHeight     =   1980
   ScaleWidth      =   5115
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Uhrenanzeige starten"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Grossanzeige fr Uhrzeit mit LCD Anzeigemodul mit IOWarrior 24
' fuer eine Anzeige mit KS 0073 LCD Controller da dieser anders als
'der originale HD 44780 adressiert wird
Dim iowHandle As Long
' Datenpuffer von IOWarrior 24
' Basic Daten  Puffer ist 3 Bytes lang: 1 Byte fr Report-ID, 2 Bytes fr Daten
Dim data(7) As Byte
Dim Posi1 As Byte
Dim Posi2 As Byte
Dim Posi3 As Byte
Dim Posi4 As Byte
Dim Ziffer As Integer


Private Sub Form_Load()
    ' Initialisieren
    ' ffnen IOWarrior
    iowHandle = IowKitOpenDevice()
    ' IOWarrior kann nicht geffnet werden
    If (iowHandle = 0) Then
        ' Beenden und Programmabbruch
        MsgBox "Can not open device!", 0, "Error"
        End
    End If
    'Einschalten der LCD
    Res = IowKitEnableLCD(iowHandle, 1, 1)
    If (Res <> 8) Then
       'Irgend etwas stimmt nicht ,exit
       MsgBox "LCD Modul nicht vorhanden ", 0, "Error"
       End
    End If
    'Initialisierung der LCD
    Res = IowKitInitLCD(iowHandle, 1, 1)
    'Display, Blinken, Cursor aus
    Res = IowKitDispControlLCD(iowHandle, 1, False, False, False)
    'CurorBewegung und kein Shift
    Res = IowKitEntryModeSet(iowHandle, 1, True, False)
    cursorOn = False
    nWritten = IowKitCursorHomeLCD(iowHandle, 1)
    End Sub
'----------------------------------------------------------------
Private Sub Command1_Click()
'Die Initialisierung des KS 0073 unterscheidet sich vom HD 44780
'Ebenfalls ist die Zhlweise der Positionen unterschiedlich
'1. Zeile 0 ... 13H
'2. Zeile 20 ... 33H
'3. Zeile 40 ... 53H
'4. Zeile 60 ... 73H
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H34)
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H9)
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H30)
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &HC)
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H1)
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H6)

LCD_NeueZeichen
nWritten = IowKitInitLCD(iowHandle, 1, 1)
M1:
Doppelpunkt
'Cursor unsichtbar schalten
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &HC)
Verzgerung
DP_aus
'Cursor unsichtbar schalten
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &HC)
Verzgerung
Zehnerstd$ = Mid$(Time$, 1, 1)
Posi1 = &H0
Posi2 = &H20
Posi3 = &H40
Posi4 = &H60
Ziffer = Val(Zehnerstd$)
Convert
Einerstd$ = Mid$(Time$, 2, 1)
Posi1 = &H4
Posi2 = &H24
Posi3 = &H44
Posi4 = &H64
Ziffer = Val(Einerstd$)
Convert
Zehnermin$ = Mid$(Time$, 4, 1)
Posi1 = &HC
Posi2 = &H2C
Posi3 = &H4C
Posi4 = &H6C
Ziffer = Val(Zehnermin$)
Convert
Einermin$ = Mid$(Time$, 5, 1)
Posi1 = &H10
Posi2 = &H30
Posi3 = &H50
Posi4 = &H70
Ziffer = Val(Einermin$)
Convert
GoTo M1
End Sub
Private Sub Convert()
Select Case Ziffer
Case 0:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(2))
Case 1:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(0) + Chr$(6) + Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(6) + Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(6) + Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(5) + Chr$(6) + Chr$(5))
Case 2:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(0) + Chr$(2))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(0) + Chr$(2) + Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(7) + Chr$(5) + Chr$(5))
Case 3:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(5) + Chr$(2))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(2))
Case 4:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(4) + Chr$(4) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(32) + Chr$(6))
Case 5:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(4) + Chr$(4) + Chr$(4))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(2))
Case 6:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(0) + Chr$(5) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(2))
Case 7:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(4) + Chr$(4) + Chr$(4) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(32) + Chr$(0) + Chr$(2))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(0) + Chr$(2) + Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(6) + Chr$(32) + Chr$(32))
Case 8:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(2))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(5) + Chr$(5) + Chr$(2))
Case 9:
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi1)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0) + Chr$(4) + Chr$(4) + Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi2)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(6) + Chr$(32) + Chr$(32) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi3)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3) + Chr$(4) + Chr$(2) + Chr$(6))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, Posi4)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32) + Chr$(5) + Chr$(5) + Chr$(2))
End Select
End Sub
'Festlegung der neuen Zeichen im Charaktergenerator RAM
Private Sub LCD_NeueZeichen()
'Zeichen Ecke von links nach rechts ansteigend unten
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H40)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(1))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(7))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(15))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
'Zeichen Ecke von links nach rechts abfallend unten
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H48)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(16))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(24))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(28))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(30))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
'Zeichen Ecke von links nach rechts ansteigend oben
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H50)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(30))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(28))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(24))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(16))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
'Zeichen Ecke von links nach rechts abfallend oben
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H58)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(15))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(7))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(1))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
'Zeichen halber Strich oben
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H60)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
'Zeichen halber Strich unten
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H68)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
'Zeichen voll ausgeflltes Feld
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H70)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
'Zeichen schraege Ecke oben halber Strich unten
nWritten = IowKitWriteCmdLCD(iowHandle, 1, &H78)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(30))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(28))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(24))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(31))
End Sub
'-----------------------------------------------------------------
Private Sub Doppelpunkt()
'Doppelpunkt auf die LCD schreiben
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H9)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &HA)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H49)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(0))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H4A)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(1))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H29)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H2A)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(2))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H69)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(3))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H6A)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(2))
End Sub
Private Sub DP_aus()
'Doppelpunkt auf der LCD lschen
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H9)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &HA)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H29)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H2A)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H49)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H4A)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H69)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
nWritten = IowKitSetDDRAMAddr(iowHandle, 1, &H6A)
nWritten = IowKitWriteStringLCD(iowHandle, 1, Chr$(32))
End Sub
Private Sub Verzgerung()
Dim Start As Long
Dim Pause As Long
Pause = 1
Start = Timer
Do While Timer < Start + Pause
DoEvents
Loop
End Sub
'-------------------------------------------------------
 Private Sub Form_Unload(Cancel As Integer)
    Res = IowKitEnableLCD(iowHandle, 1, 0)
    ' Close IO-Warrior device
    IowKitCloseDevice (iowHandle)
End Sub
 '--------------------------------------------------------
 Private Sub Ausschalten()
  Rem berschrift ber Commando loeschen
'  ReadLabel.Caption = "                          "
  End Sub




